## flexml 1.8

=== Makefile ===
# Make(1) rules for FleXML XML processor generator system.
# Copyright (c) 1999 Kristoffer Rose.  All rights reserved.
#
# This file is part of the FleXML XML processor generator system.
# Copyright (c) 1999 Kristoffer Rose.  All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA.

# $Id: Makefile,v 1.44 2006/09/29 19:00:17 wdowling Exp $

# SUFF (defined in Makefile.defs) is the versioning suffix added to binaries and
# resource files. To get rid of it (and do a non-versioned install,
# for example), do:
#   make whatever SUFF=

# FILES.

include Makefile.defs

STUFF =	GPL Makefile Makefile.defs flexml.pl FleXML.html
BINS  =	$(FLEXML)
LIBS  =	$(FLEXML_ACT)
DATA  =	skel
MANS  =	flexml.1
DOCS  =	README NOTES TODO flexml-act.dtd
HTMLS =	FleXML.html paper.html

SRC =	$(STUFF) $(DATA) $(DOCS) $(HTMLS)
ALL =	$(PROGS) $(LIBS) $(DATA) $(MANS) $(DOCS) $(HTMLS)

.PHONY:		all install dist test clean

# PRIMARY TARGETS.

all:		$(ALL)

install:	$(ALL)
	mkdir -p $(DESTDIR)$(BINDIR) $(DESTDIR)$(LIBDIR) \
		$(DESTDIR)$(MAN1DIR) $(DESTDIR)$(DOCDIR) \
		$(DESTDIR)$(DATADIR) \
		$(DESTDIR)$(DOCDIR)/html \
		$(DESTDIR)$(DOCDIR)/examples
	$(INSTALL) -m555 $(BINS) $(DESTDIR)$(BINDIR)/
	$(INSTALL) -m555 $(LIBS) $(DESTDIR)$(LIBDIR)/
	$(INSTALL) -m444 $(DATA) $(DESTDIR)$(DATADIR)/
	$(INSTALL) -m444 $(MANS) $(DESTDIR)$(MAN1DIR)/
	$(INSTALL) -m444 $(DOCS) $(DESTDIR)$(DOCDIR)/
	$(INSTALL) -m444 $(HTMLS) $(DESTDIR)$(DOCDIR)/html/
	if test "x$(SUFF)" != "x" ; then \
	  rm -f $(DESTDIR)$(BINDIR)/flexml; \
	  ln -s $(DESTDIR)$(BINDIR)/$(FLEXML) $(DESTDIR)$(BINDIR)/flexml;\
	fi
	$(MAKE) -C examples install

FLEXML_DISTDIR = $(FLEXML)-$(VER)
dist:	test clean
	@echo "Building distribution..."
	mkdir $(FLEXML_DISTDIR)
	cp $(STUFF) $(DATA) $(DOCS) $(HTMLS) flexml-act-bootstrap.c \
		$(FLEXML_DISTDIR)
	cp -r examples testbed $(FLEXML_DISTDIR)
	find $(FLEXML_DISTDIR) -name CVS | xargs rm -rf
	find $(FLEXML_DISTDIR) -name .cvsignore | xargs rm -rf
	tar cvfz $(FLEXML_DISTDIR).tar.gz $(FLEXML_DISTDIR)
	rm -rf $(FLEXML_DISTDIR)

	#rsync -v FleXML.html $(WEBHOME)/FleXML.html
	#rsync -va --cvs-exclude --delete-excluded ./ $(FTPHOME)/

clean::; @echo "Cleaning..."
	$(RM) -rf $(FLEXML_DIR).tar.gz $(FLEXML_DIR)
	$(RM) *.[olh1] *-dummy.? lex.* *~ ./#*
	find -name '*~' | xargs $(RM)
test::		all
	@echo "Testing..."

clean::; $(RM) $(FLEXML) $(FLEXML_ACT) flexml-act flexml-act.c

$(FLEXML):		flexml.pl
	sed \
	    -e "s;[.][/]flexml-act;$(ACT);g" \
	    -e "s;[.][/]skel;$(SKEL);g" \
	    -e "s;/var/tmp;$(TMPDIR);g" \
	    -e "s;/usr/share/doc/;$(DOCDIR)/;g" flexml.pl > $@
	chmod +x $@

ifneq ($(SUFF),)
$(FLEXML_ACT): flexml-act
	cp flexml-act $@
endif

# Action language...
flexml-act.l:		flexml-act.dtd skel
	$(PERL) ./flexml.pl $(FLEXDEBUG) -Lv -ractions -s skel $<

flexml-act.c:		flexml-act.l
	$(FLEX) -B -s -v -oflexml-act.c flexml-act.l

flexml-act.o:		flexml-act.c flexml-act.h
flexml-act-bootstrap.o:	flexml-act-bootstrap.c flexml-act.h
flexml-act:		flexml-act.o flexml-act-bootstrap.o

clean::; $(RM) TAGS
TAGS: 	$(SRC);	etags $(SRC)
ci:	$(SRC);	ci -u $(SRC)

# DOCUMENTS.

clean::; $(RM) flexml.html index.html pod2html-*

flexml.1:	$(FLEXML)
	$(POD2MAN) $(FLEXML) > $@

flexml.html:	$(FLEXML)
	$(POD2HTML) < $(FLEXML) > $@

index.html:	FleXML.html
	sed 's.ftp/FleXML/..g' FleXML.html > $@

# TESTS.

clean::; $(MAKE) -C examples $@; $(MAKE) -C testbed $@
test::;  $(MAKE) -C examples $@; \
		$(MAKE) -C testbed $@ > test.out 2>&1; ! grep '^fail' test.out && \
		echo "Tests succeeded."


# END.

clean::; @echo "Done cleaning."
test::;	@echo "Done testing."

=== examples/Makefile ===
# Make(1) rules for FleXML XML processor generator system.
# Copyright (c) 1999 Kristoffer Rose.  All rights reserved.
#
# This file is part of the FleXML XML processor generator system.
# Copyright (c) 1999 Kristoffer Rose.  All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA.

# $Id: Makefile,v 1.9 2006/09/29 19:40:46 wdowling Exp $

# FILES.

include ../Makefile.defs

# Test the version in this dir, not the installed one
SKEL=../skel
ACT=../flexml-act

SAMPS =	my.dtd my-show.act my-joke.xml my-joke2.xml my-joke3.xml \
	tricky.dtd tricky.act tricky.xml \
	test.html xhtml1-transitional.dtd

SRC =	$(SAMPS)
ALL =	$(SAMPS)

.PHONY:		all install dist test clean

# PRIMARY TARGETS.

start: test

all:		$(ALL)

install:	$(ALL)
	mkdir -p $(DESTDIR)$(DOCDIR)/flexml/examples
	$(INSTALL) -m444 $(SAMPS) $(DESTDIR)$(DOCDIR)/flexml/examples/

dist:		clean
	#rsync -v FleXML.html $(WEBHOME)/FleXML.html
	#rsync -va --cvs-exclude --delete-excluded ./ $(FTPHOME)/

clean::; @echo "Cleaning examples..."
	$(RM) *.[olh1] *-dummy.? lex.* *~ ./#*

test::		all
	@echo "Testing..."


# DEFAULT RULES.
FLEXML_PROG = ../$(FLEXML) -s$(SKEL) -T$(ACT)

# Generate C source from flex scanner.
%.c: 		%.l
	$(FLEX) -B -s -v $(FLEXDEBUG) -o$@ $<

# Direct generation of stand-alone XML processor+application.
# Note: The dependency must be of the form "appl.l: appl.act proc.dtd".
%.l:		%.act
	$(FLEXML_PROG) $(FLEXDEBUG) -vA -a $^

# Generate XML processor to link with application.
%.l %.h:	%.dtd
	$(FLEXML_PROG) $(FLEXDEBUG) -v $<

# Generate XML application C source to compile and link with processor.
# Note: The dependency must be of the form "appl.c: appl.act proc.dtd".
%.c:		%.act
	$(FLEXML_PROG) $(FLEXDEBUG) -vD -a $^


clean::; $(RM) flexml-act flexml-act.c

# Example: LINK processor with application:

my.l my.h:	my.dtd
my.c:		my.l
my.o:		my.c my.h

my-show.c:	my-show.act my.dtd
my-show.o:	my-show.c my.h
my-show:	my-show.o my.o

test::		my-show
	@echo "XXXXX Test: LINK processor with application"
	if ./my-show <my-joke.xml  ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi
	if ./my-show <my-joke2.xml ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi
	if ./my-show <my-joke3.xml ; then echo "TEST FAILED"; else echo "TEST PASSED"; fi

clean::; $(RM) my.c my-show my-show.c my-dummy my-dummy.c

# Example: COMPILE processor into application

tricky.l:	tricky.act tricky.dtd
tricky.c:	tricky.l
tricky.o:	tricky.c
tricky:		tricky.o

test::		tricky
	@echo "XXXXX Test: COMPILE processor with application"
	if ./tricky <tricky.xml ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi

clean::; $(RM) tricky.[lco] tricky

# Complex example: application to print XHTML <a href=...> values.

xhtml1-transitional.l xhtml1-transitional.h: xhtml1-transitional.dtd
	$(FLEXML_PROG) -rhtml \
		-p "-//IETF//DTD XHTML 1.0 Transitional//EN" \
		-u "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" \
		xhtml1-transitional.dtd

xhtml1-transitional.c:	xhtml1-transitional.l
	$(FLEX) -B -s -v -Ca -oxhtml1-transitional.c xhtml1-transitional.l

# turn off the -O2 when building this -- it takes too long to run
xhtml1-transitional.o: CFLAGS = -g

xhtml1-transitional.o:	xhtml1-transitional.c xhtml1-transitional.h

xhtml-href.c:	xhtml-href.act xhtml1-transitional.dtd
xhtml-href.o:	xhtml-href.c xhtml1-transitional.h
xhtml-href:	xhtml-href.o xhtml1-transitional.o

test::		xhtml-href FleXML.xml
	@echo "XXXXX Test: application to print XHTML <a href=...> values"
	if ./xhtml-href <test.html   ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi
	if ./xhtml-href < FleXML.xml ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi

clean::; $(RM) xhtml1-*.[lhco] xhtml-href.[co] xhtml-href

# END.

clean::; @echo "Done cleaning."
test::;	@echo "Done testing."
test:: clean

.PHONEY : echov

# on command line say 'make v=foo echov' to see the value
# of the variable foo
echov:
	@echo "$(subst ",\",$($(v)))";          #"# for emacs

=== testbed/Makefile ===
# $Source: /cvsroot/flexml/flexml/testbed/Makefile,v $

# regression testbed Makefile

#####################################################
#  Fixed definitions -- do not modify for new tests
#####################################################

include ../Makefile.defs

MAKEUTILS_DIR = .

# If UNIT_TESTS is     test_foo
# and test_foo_out is  bar baz
# Then the created files (that need to be deleted by 'make clean'
# will be
# test_foo  foo.std{err,out} foo.std{err,out}.diff  bar baz  bar.diff baz.diff
TEST_INTERMEDIATES = \
	$(UNIT_TESTS) \
	$(UNIT_TESTS:test_%=%.stdout) $(UNIT_TESTS:test_%=%.stdout.diff) \
	$(UNIT_TESTS:test_%=.test_%.stdout.expected) \
	$(UNIT_TESTS:test_%=%.stderr) $(UNIT_TESTS:test_%=%.stderr.diff) \
	$(UNIT_TESTS:test_%=.test_%.stderr.expected) \
	$(foreach var,$(UNIT_TESTS:%=%_out),$(foreach o,$($(var)),$o $(o).diff))

# Compares test.out.std[out,err] with expected values
COMPARE_OUT = $(MAKEUTILS_DIR)/CompareOut.pl

#CC = /usr/bin/gcc-3.3 -Wall
#CFLAGS = -O2 -g
#FLEXDEBUG = -d

FLEXML = ../flexml -s ../skel -T../flexml-act

.PHONY : test
.PHONY : clean

#####################################################
#  test definitions -- add new tests here
#####################################################

EXES = \
	biparser \
	init_header \
	missing-att \
	mixed-enumatt \
	mixed-enumatt2 \
	mixed-stratt \
	mixed-stratt-def \
	mixed1 \
	multi-parser-run


INTERMEDIATES = $(EXES) $(EXES:%=%.c) $(EXES:%=%.l)

# leave this alphabetically sorted for easy scanning
UNIT_TESTS = \
	test_biparser \
	test_init_header \
	test_missing-att \
	test_mixed-enumatt \
	test_mixed-enumatt2 \
	test_mixed-stratt \
	test_mixed-stratt-def \
	test_mixed1 \
	test_multi-parser-run

test : $(UNIT_TESTS)

# Test init_header
test_init_header_cmd  = ./init_header < init_header.in
test_init_header_deps = init_header init_header.in

# Test missing REQUIRED attribute
test_missing-att_cmd  = ./missing-att < missing-att.in
test_missing-att_deps = missing-att missing-att.in

# Test mixed1
test_mixed1_cmd  = ./mixed1 < mixed1.in
test_mixed1_deps = mixed1 mixed1.in

# Test mixed-enumatt (mixed content + enumerated attribute)
test_mixed-enumatt_cmd  = ./mixed-enumatt < mixed-enumatt.in
test_mixed-enumatt_deps = mixed-enumatt mixed-enumatt.in

# Test mixed-enumatt2 (mixed content + enumerated attribute, eval'ed in end tag)
test_mixed-enumatt2_cmd  = ./mixed-enumatt2 < mixed-enumatt2.in
test_mixed-enumatt2_deps = mixed-enumatt2 mixed-enumatt2.in

# Test mixed-stratt (mixed content + string attribute)
test_mixed-stratt_cmd  = ./mixed-stratt < mixed-stratt.in
test_mixed-stratt_deps = mixed-stratt mixed-stratt.in

# Test mixed-stratt (mixed content + default string attribute)
test_mixed-stratt-def_cmd  = ./mixed-stratt-def < mixed-stratt-def.in
test_mixed-stratt-def_deps = mixed-stratt-def mixed-stratt-def.in

# Test multi-parser-run (Run the parser several times on "different" files)
test_multi-parser-run_cmd = ./multi-parser-run multi-parser-run.in
test_multi-parser-run_deps = multi-parser-run multi-parser-run.in

# Test biparser (Have two parsers in the same code)
test_biparser_cmd = ./biparser biparser-one.in biparser-two.in
test_biparser_deps = biparser biparser-one.in biparser-two.in

biparser: biparser-one.dtd biparser-two.dtd biparser.precious.c
	for n in one two ; do \
	  $(FLEXML) -P$$n -H biparser-$$n.h -L biparser-$$n.dtd; \
	  $(FLEXML) -P$$n -S biparser-$$n.l -L biparser-$$n.dtd; \
	  $(FLEX) -s -L -P$${n}_ -obiparser-$$n.c biparser-$$n.l; \
	done
	$(CC) $(CFLAGS) -o biparser  \
              biparser-one.c biparser-two.c \
	      biparser.precious.c
CLEANFILES+= biparser-one.h biparser-one.l biparser-one.c \
	     biparser-two.h biparser-two.l biparser-two.c

init_header : init_header.act init_header.dtd init_header.h
	$(FLEXML) -b 1000 -A  -i$@.h -a$@.act $@.dtd
	$(FLEX) -s -L -o$@.c $@.l
	$(CC) $(CFLAGS) -o $@ $@.c

% : %.dtd %.act
	$(FLEXML) -b 1000 -A  -a$@.act $@.dtd
	$(FLEX) -s -L -o$@.c $@.l
	$(CC) $(CFLAGS) -o $@ $@.c

##############################################################
#  test build rules -- add override build rules here if needed
##############################################################

#mixed1: mixed1.dtd mixed1.act
#	$(FLEXML) -b 500 -A  -amixed1.act mixed1.dtd
#	$(FLEX) -s -L -o mixed1.c mixed1.l > mixed1.c
#	$(CC) $(CFLAGS) -o $@ mixed1.c


#####################################################
#  test infrastructure -- do not modify for new tests
#####################################################

clean :
	rm -f $(TEST_INTERMEDIATES) $(INTERMEDIATES) $(CLEANFILES)

#  When we are building test_foo, the variable $(TEST_BASE) is "foo"
test_% : TEST_BASE = $(@:test_%=%)

ifndef distribute_deps
# This will take a target and dependency list, and evaluate each dependency
# individually. This only needs to be used on dependency lists that are to
# be in an $(eval ...) function. This is a work-around for a bug in GNU Make
# 3.80, which fails when $(eval)'ing dependency lists longer than about 160
# characters.
#   1. target
#   2. dependency list
define distribute_deps
$(foreach dep,$(2),$(eval $(1) : $(dep)))
endef
endif

define unit_test_deps_t
$(1) : .$(1).stdout.expected
$(1) : .$(1).stderr.expected
$$(call distribute_deps,$(1),$($(1)_deps))
endef

$(foreach test,$(UNIT_TESTS),$(eval $(call unit_test_deps_t,$(test))))


# To build .test_foo.std{err,out}.expected --
#    If foo.std{err,out}.expected exists, symlink to it
#    Else, .test_foo.std{err,out}.expected is a new empty file
# These rules are invoked from rules in the Extradeps section.
# They must be two separate rules (else 'make test' not idempotent
# -- see bug #105)
.test_%.stderr.expected:
	@if [ -f  $(@:.test_%=%) ]; \
		then $(SYMLINK) $(@:.test_%=%) $@; \
		else touch $@; \
	fi
.test_%.stdout.expected:
	@if [ -f  $(@:.test_%=%) ]; \
		then $(SYMLINK) $(@:.test_%=%) $@; \
		else touch $@; \
	fi


# Unit test rule.  Expects:
# UNIT_TESTS = test_foo test_bar    (test_ prefix is necessary)
# test_foo_cmd  =  command to run
# test_foo_deps =  dependencies (i.e. inputs to the test, and the executable)
# test_foo_out  =  files and directories created by running the command
#                  with corresponding .expected files for comparison 

$(UNIT_TESTS) :
	@$(test_$(@:test_%=%)_cmd) > $(@:test_%=%).stdout \
	    2>$(@:test_%=%).stderr || true
	@$(PERL) $(COMPARE_OUT) -p '$($(@)_diff_prog)' -- \
	    $($(@)_diff_opts) $(@:test_%=%) $($(@)_out) | tee $@

=== debian/changelog ===
flexml (1.8-1.1) unstable; urgency=low

  [ Jari Aalto ]
  * Non-maintainer upload.
  * debian/control
    - Update to debhelper 7.1.
  * debian/rules
    - Add target 'get-changelog'.
  * debian/source/format
    - New file; fix Lintian missing-debian-source-format.
  * debian/watch
    - New file; fix Lintian debian-watch-file-is-missing.
  * flexml.pl
    - Fix spelling error (Lintian).
  * ChangeLog
    - New file. Downloaded from development site.

  [ Jan Hauke Rahm ]
  * Updating the flexml Uploaders list (Closes: #521446)
  * Change doc-base section to "Programming"
  * Add examples directory
  * Add Homepage field
  * Slight modification of debian/copyright to be more precise
  * Switch to debhelper 7 and by that
    + acknowledge DEB_BUILD_OPTIONS
    + use doc-base trigger instead of generating debian/post*
  * As a consequence, bump standards-version to 3.8.4

 -- Jari Aalto <jari.aalto@cante.net>  Thu, 13 May 2010 16:17:39 +0300

flexml (1.8-1) unstable; urgency=low

  * Do not load unistd on windows platforms since this does not exist
  * Improve the error message when receiving an opening tag instead of
    the expected closing tag. This happens at least when the DTD
    enforces the tag order and this order is not followed.

 -- Martin Quinson <mquinson@debian.org>  Thu, 11 Oct 2007 11:55:58 +0200

flexml (1.7-1) unstable; urgency=low

  [William Dowling]
  * Change the static buffstack into two dynamically allocated stacks.
    This get rids of any stack size limitation;
    This also solves #1529930 (parsing mixed content fails on sparc/solaris,
    which were caused by misaligned pointers)
  * Fix #1538171: Only display the stacknames when they are defined (they
    are not in the prolog)
  * Fix a bufferstack memleak. This fixes both leaks of attributes and leaks
    of pcdata. People using large XML files shouldn't have to use insane
    buffsizes anymore.
  * Fix bug #1558023 'REQUIRED attributes not validated correctly'.
  * Add -i command-line param to #include given file in output .l.
  * Add a proper regression testing infrastructure and some test cases.

 -- Martin Quinson <mquinson@debian.org>  Sat, 16 Sep 2006 00:44:05 +0200

flexml (1.5.3-1) unstable; urgency=low

  * New option: --sysid to override the system id
  * Kill any non ascii char from the distrib. They were latin1, I use utf8
    so they annoyed me for not much benefit. I could have switched to utf8,
    but it would have annoyed other people, I'm sure.
  * Kill the EnlargeFlex.patch: was integrated into flex a few ages ago.

 -- Martin Quinson <mquinson@debian.org>  Tue, 18 Jul 2006 19:40:36 +0200

flexml (1.5.2-1) unstable; urgency=low

  * Bug fix: do find the skeleton file in installed distributions

 -- Martin Quinson <mquinson@debian.org>  Tue, 18 Jul 2006 14:06:50 +0200

flexml (1.5.1-1) unstable; urgency=low

  * Tests used to rely on wget to fetch a dtd. Include this in the tarball
    instead.

 -- Martin Quinson <mquinson@debian.org>  Thu, 13 Jul 2006 21:47:45 +0200

flexml (1.5-1) unstable; urgency=low

  [William Dowling]
  * Fix bug 1498401 "Parser loops on empty entity expansion" (l. 251);
  * Fix bug 1498407 "Cannot have ELEMENT with same name as ATTLIST" (ll. 674-5);
  * Fix bug 1498418 "ENTITY attribute type unimplemented." (ll. 842-51).

  [Martin Quinson]
  (upstream)
  * Switch to Getopt::Long (I hope I didn't break anything)
  * Add long version of each command line option
  * Allow to override the scanner, header, application names using an
    optionnal argument along to -S -H -A options.
  (debian package)
  * Switch to debhelper level 5 (at least try to, change seem to be ignored)
  * Run the test suite in the process of package building

 -- Martin Quinson <mquinson@debian.org>  Thu, 13 Jul 2006 20:27:50 +0200

flexml (1.4.1-1) unstable; urgency=low

  * More fixes to get several parsers in the same C code:
    - pass bufferstack to static too
    - prefix the pcdata variable (WARNING: go fix your code using it)
    This seems to be needed with gcc 4.x

 -- Martin Quinson <mquinson@debian.org>  Sat, 22 Apr 2006 01:29:23 +0200

flexml (1.4-1) unstable; urgency=low

  [Arnaud Legrand]
  * Add a -P option to enable multiple versions of flexml to live in the
    same C code.
  * Make flexml work with the current flex (2.5.33) that seem to dislike
    ]] in the comments. Bug against flex underway.

  [Martin Quinson]
  * Do test the version in the current dir, not the installed one.
  * Normalize the distributed archive name and content layout.

 -- Martin Quinson <mquinson@debian.org>  Tue, 21 Mar 2006 14:03:16 +0100

flexml (1.3-1) unstable; urgency=low

  [William Dowling]
  (infrastructure)
  * Enhance main makefile to allow versionned installs
  * Various cleanups to the makefiles
  * Get a working "make test" (some of the tests themselves are still to be
    fixed)
  (generated parsers)
  * Don't allocate the statenames array over and over (plug memleak)
  * Try not to exaust the stack when possible

  [Ulrik Petersen]
  * Fix statenames array on terminaison (plug memleak)

  [Martin Quinson]
  (flexml.pl script)
  * Get paranoid on file open()/close().
  (infrastructure)
  * Let FleXML.html be valid XHTML1.1 (so that it can be used in tests)
  * Install the paper as documentation
  (debian package)
  * Fix the doc-base file (Closes: #303220).

 -- Martin Quinson <mquinson@debian.org>  Wed,  6 Apr 2005 12:27:04 +0200

flexml (1.2-2) unstable; urgency=low

  * drop conflict on flex-old since oldies are harmless here.

 -- Martin Quinson <mquinson@debian.org>  Wed, 23 Feb 2005 22:04:14 +0100

flexml (1.2-1) unstable; urgency=low

  [Martin Quinson]
  * Add a \n after the error messages when not using quiet_parsers
  * Clarify the licence of the produced parsers. Thanks to Ulrik Petersen
    for proposing the patch, and to Kristoffer H Rose for forwarding it.

  [Arnaud Legrand]
  * Add a -b option to modify the default FLEXML_BUFFERSTACKSIZE.


=== debian/control ===
Source: flexml
Section: devel
Priority: optional
Maintainer: Martin Quinson <mquinson@debian.org>
Build-Depends: libwww-perl, debhelper (>= 7.1),  liburi-perl,
 libdate-calc-perl, flex
Standards-Version: 3.8.4
Homepage: http://flexml.sourceforge.net/

Package: flexml
Architecture: any
Depends: ${shlibs:Depends}, libwww-perl, liburi-perl, libdate-calc-perl,
 ${misc:Depends}
Recommends: flex
Description: generate fast validating XML processors and applications
 FleXML makes it easy to generate very fast validating XML processors
 as flex(1) source.
 .
 By design it can only handle documents using an external DTD.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Run this rule manually when new upstream release is available
get-changelog:
	lynx -dump http://sourceforge.net/news/?group_id=34654 > ChangeLog

%:
	dh $@

## flexml 1.9.2

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # with this program; if not, write to the Free Software Foundation, Inc., 59
 # Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 
-# $Id: Makefile,v 1.44 2006/09/29 19:00:17 wdowling Exp $
+# $Id: Makefile,v 1.45 2011/10/30 19:26:34 mquinson Exp $
 
 # SUFF (defined in Makefile.defs) is the versioning suffix added to binaries and
 # resource files. To get rid of it (and do a non-versioned install,
@@ -34,7 +34,7 @@
 LIBS  =	$(FLEXML_ACT)
 DATA  =	skel
 MANS  =	flexml.1
-DOCS  =	README NOTES TODO flexml-act.dtd
+DOCS  =	README ChangeLog NEWS NOTES TODO flexml-act.dtd
 HTMLS =	FleXML.html paper.html
 
 SRC =	$(STUFF) $(DATA) $(DOCS) $(HTMLS)

=== debian/changelog ===
flexml (1.9.2-1) unstable; urgency=low

  * New upstream release:
    - Declare *_isset variables properly, even when they are in a header
      [Thx Arnaug Giersch for the BR and patch] Closes: #647605)
  * debian/control: 
    - add VCS fields, and improve short description
    - update Standard-Version to 3.9.2 (no change needed)

 -- Martin Quinson <mquinson@debian.org>  Fri, 04 Nov 2011 14:56:17 +0100

flexml (1.9.1-1) unstable; urgency=low

  * New upstream release:
    - include small changes from the debian package
    - Add a NEWS and a ChangeLog file

 -- Martin Quinson <mquinson@debian.org>  Sun, 30 Oct 2011 22:12:15 +0100

flexml (1.9-1) unstable; urgency=low

  * New upstream release:
    - be more defensive against multiply defined attributes

 -- Martin Quinson <mquinson@debian.org>  Sun, 30 Oct 2011 18:47:09 +0100

=== debian/control ===
Source: flexml
Section: devel
Priority: optional
Maintainer: Martin Quinson <mquinson@debian.org>
Build-Depends: libwww-perl, debhelper (>= 7.1),  liburi-perl,
 libdate-calc-perl, flex
Standards-Version: 3.9.2
Homepage: http://flexml.sourceforge.net/
Vcs-Git: git://git.debian.org/git/collab-maint/flexml.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/flexml.git

Package: flexml
Architecture: any
Depends: ${shlibs:Depends}, libwww-perl, liburi-perl, libdate-calc-perl,
 ${misc:Depends}
Recommends: flex
Description: Fast validating XML processors and applications generator
 FleXML makes it easy to generate very fast validating XML processors
 as flex(1) source.
 .
 By design it can only handle documents using an external DTD.

## flexml 1.9.6

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # with this program; if not, write to the Free Software Foundation, Inc., 59
 # Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 
-# $Id: Makefile,v 1.45 2011/10/30 19:26:34 mquinson Exp $
+# $Id: Makefile,v 1.47 2013/01/29 14:35:24 mquinson Exp $
 
 # SUFF (defined in Makefile.defs) is the versioning suffix added to binaries and
 # resource files. To get rid of it (and do a non-versioned install,
@@ -29,7 +29,7 @@
 
 include Makefile.defs
 
-STUFF =	GPL Makefile Makefile.defs flexml.pl FleXML.html
+STUFF =	GPL Makefile Makefile.defs flexml.pl
 BINS  =	$(FLEXML)
 LIBS  =	$(FLEXML_ACT)
 DATA  =	skel
@@ -90,6 +90,7 @@
 
 $(FLEXML):		flexml.pl
 	sed \
+	    -e "s;FLEXMLVERSION;$(VER);g" \
 	    -e "s;[.][/]flexml-act;$(ACT);g" \
 	    -e "s;[.][/]skel;$(SKEL);g" \
 	    -e "s;/var/tmp;$(TMPDIR);g" \

=== examples/Makefile ===
--- 
+++ 
@@ -44,8 +44,8 @@
 all:		$(ALL)
 
 install:	$(ALL)
-	mkdir -p $(DESTDIR)$(DOCDIR)/flexml/examples
-	$(INSTALL) -m444 $(SAMPS) $(DESTDIR)$(DOCDIR)/flexml/examples/
+	mkdir -p $(DESTDIR)$(DOCDIR)/examples
+	$(INSTALL) -m444 $(SAMPS) $(DESTDIR)$(DOCDIR)/examples/
 
 dist:		clean
 	#rsync -v FleXML.html $(WEBHOME)/FleXML.html

=== testbed/Makefile ===
--- 
+++ 
@@ -43,6 +43,7 @@
 	biparser \
 	init_header \
 	missing-att \
+	multiple-att \
 	mixed-enumatt \
 	mixed-enumatt2 \
 	mixed-stratt \
@@ -58,6 +59,7 @@
 	test_biparser \
 	test_init_header \
 	test_missing-att \
+	test_multiple-att \
 	test_mixed-enumatt \
 	test_mixed-enumatt2 \
 	test_mixed-stratt \
@@ -74,6 +76,10 @@
 # Test missing REQUIRED attribute
 test_missing-att_cmd  = ./missing-att < missing-att.in
 test_missing-att_deps = missing-att missing-att.in
+
+# Test multiply defined attribute
+test_multiple-att_cmd  = ./multiple-att < multiple-att.in
+test_multiple-att_deps = multiple-att multiple-att.in
 
 # Test mixed1
 test_mixed1_cmd  = ./mixed1 < mixed1.in

=== debian/changelog ===
flexml (1.9.6-6) unstable; urgency=medium

  * Team upload

  [ Jelmer Vernooĳ ]
  * Migrate repository from alioth to salsa.

  [ Andreas Tille ]
  * Secure URI in watch file
  * d/copyright: DEP5
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * debian/docs: Removed since installed by upstream Makefile anyway
  * Permit failure of blhc in Salsa CI

  [ Arnaud Giersch ]
  * Fix spurious semicolon in generated file
    Closes: #981730

  [ Lucas Nussbaum ]
  * Fix FTBFS with GNUMAKEFLAGS=--shuffle=reverse
    Closes: #1104757, #1105348

 -- Andreas Tille <tille@debian.org>  Sat, 26 Jul 2025 16:06:21 +0200

flexml (1.9.6-5) unstable; urgency=medium

  * Do not produce code with sprintf (security vulnerability).
  * d/ctrl: Update the standard-version to 3.9.8 (no change needed)

 -- Martin Quinson <mquinson@debian.org>  Wed, 01 Jun 2016 11:36:26 +0200

flexml (1.9.6-4) unstable; urgency=medium

  * Rework how the output is sorted, so that it still compiles SimGrid.
  * d/p/FTBFS-pedantic: remove -ansi -pedantic flag as Flex parsers
    don't compile with these flags on modern compilers (Closes: #813462).

 -- Martin Quinson <mquinson@debian.org>  Mon, 08 Feb 2016 17:16:45 +0100

flexml (1.9.6-3) unstable; urgency=medium

  * Produce reproducible files by explicitly sorting the elements.
    This greatly reduces the diffs' size when regenerating the files.
  * d/control: Update Standards-Version to 3.9.6 (no change needed).

 -- Martin Quinson <mquinson@debian.org>  Mon, 26 Jan 2015 15:20:17 +0100

flexml (1.9.6-2) unstable; urgency=medium

  * d/ctrl: Update the standard-version to 3.9.6 (no change needed)
  * d/p/privacy_breach: don't fetch any logo dynamically from SF as it
    may be seen (e.g., by Lintian) as a privacy breach.

 -- Martin Quinson <mquinson@debian.org>  Thu, 20 Nov 2014 08:47:44 +0100

flexml (1.9.6-1) unstable; urgency=low

  * New upstream release:
    Don't install any file under /usr/share/doc/flexml/flexml/*
    Thanks lintian for noticing, and sorry for the short lived v1.9.5.

 -- Martin Quinson <mquinson@debian.org>  Tue, 29 Jan 2013 16:12:03 +0100

flexml (1.9.5-1) UNRELEASED; urgency=low

  * New upstream release.
    - flexml --version now returns the package version (instead of the
      file release in upstream RCS).
  * debian/control: Use canonical values in fields VCS (thanks lintian)

 -- Martin Quinson <mquinson@debian.org>  Tue, 29 Jan 2013 15:37:08 +0100

flexml (1.9.4-2) unstable; urgency=low

  * Update Standards-Version to 3.9.4 (no change)
  * Switch to debhelper compatibility level 9
    This brings neat hardening features that lintian were asking for

 -- Martin Quinson <mquinson@debian.org>  Thu, 27 Dec 2012 21:21:37 +0100

flexml (1.9.4-1) unstable; urgency=low

  * New upstream release:
    - avoid ambiguous C identifiers even if XML names contain
      underscores [Thx Arnaud Giersch for report and patch]

 -- Martin Quinson <mquinson@debian.org>  Thu, 20 Dec 2012 01:26:05 +0100

flexml (1.9.3-1) unstable; urgency=low

  * New upstream release:
    - Avoid undefined behaviors breaking clang's optimizations
      [Thx Arnaud Giersch for the BR and patch] (Closes: #674524)

 -- Martin Quinson <mquinson@debian.org>  Thu, 05 Jul 2012 16:36:02 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: devel
 Priority: optional
 Maintainer: Martin Quinson <mquinson@debian.org>
-Build-Depends: libwww-perl, debhelper (>= 7.1),  liburi-perl,
+Build-Depends: libwww-perl, debhelper-compat (= 13),  liburi-perl,
  libdate-calc-perl, flex
-Standards-Version: 3.9.2
+Standards-Version: 4.7.2
 Homepage: http://flexml.sourceforge.net/
-Vcs-Git: git://git.debian.org/git/collab-maint/flexml.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/flexml.git
+Vcs-Git: https://salsa.debian.org/debian/flexml.git
+Vcs-Browser: https://salsa.debian.org/debian/flexml
 
 Package: flexml
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_installexamples:
	# Upstream Makefile installs a couple of examples without write permissions.
	# Just make dh_installexamples work
	chmod u+w debian/flexml/usr/share/doc/flexml/examples/*
	dh_installexamples

=== debian/watch ===
version=4
https://sf.net/flexml/flexml-(.+)\.tar\.gz
